#include "transxstate.h"
#include "TransXFunction.h"

#ifndef __BASEFUNCTION_H
#define __BASEFUNCTION_H

#include "mfdvartypes.h"
#include "TransXFunction.h"
#include "planfunction.h"

class basefunction : public TransXFunction
{
private:
	void switchplantype();
	void switchmanoevremode();
	void switchadvanced();
	void loadplan(int plan);
	void Getmode2hypo(VECTOR3 *targetvel);

	virtual void dolowpriaction();
	int iplantype,iplan;
	bool interceptflag;
	bool previousexists;
	class mapfunction *mappointer;
	class plan *planpointer;
	int positionnumber;
	int interceptwith;
	ORBITTIME mode2orbittime,deltavel;
protected:
	INTERCEPT primary, pecorrintercept;
	ORBIT craft, rmin, basisorbit, hypormaj, craftincontext, target, context;
	OBJHANDLE hcontext;
	GRAPH graph;
	bool hypoorcraft, showintercept, showrinc;
	MFDvarmoon m_target,m_minor;
	MFDvardiscrete m_planauto, m_plantype,m_planinitial,m_planthrough,m_planminor;
	MFDvardiscrete m_manoevremode,m_updbaseorbit;
	MFDvarfloat m_prograde,m_outwardvel,m_chplvel;
	MFDvarMJD m_ejdate;
	MFDvardiscrete m_intwith,m_graphprj,m_scale,m_advanced;
	int gettargettype(){return m_plantype;};
	void autoplan();
public:
	void calculate(VECTOR3 *targetvel);
	int calcnewview(int oldview);
	bool soistatus();
	void processvisiblevars();
	void updateplan();//Actually changes the plan
	void setplanstate(int plantype,int plan);//selects the type of plan to be carried out
	void setnextplanstate(int plantype,int plan,int targettype);
	void getplanstate(int *xplantype,int *xplan,int *targettype);
	virtual void doupdate(HDC hDC, int tw, int th,int viewmode);
	virtual bool initialisevars();
	virtual void saveself(FILEHANDLE scn);
	virtual void restoreself(FILEHANDLE scn);
	void handlesfornextfunction(OBJHANDLE *thmajor, OBJHANDLE *thminor);
	class plan *getplanpointer(){return planpointer;};
	ORBIT getcraftorbit(){return craft;};
	ORBIT getpassforwardorbit();
	void getcraftorbitattarget(ORBIT *tcraft);
	ORBIT getcontextorbit(){return context;};//Returns copy of context orbit
	ORBIT getminororbit(){return rmin;};
	ORBIT getmanoevreorbit(){return hypormaj;};
	ORBIT gettargetorbit(){return target;};//Returns copy of target orbit
	void gettransxstateparams(class transxstate **tstate, int *tpositionnumber){*tstate=state;*tpositionnumber=positionnumber;};
	basefunction(class transxstate *tstate, int tpositionnumber,OBJHANDLE thmajor, OBJHANDLE thminor);
	~basefunction();
};

#endif