#ifndef __TRANSXSTATE_H
#define __TRANSXSTATE_H
#include "mfdfunction.h"
#define NUMFUNCTIONS 100

class transxstate:private MFDFunction {
public:
	transxstate();
	~transxstate();

	virtual void dolowpriaction();

	bool doupdate(HDC hDC,int tw, int th, int currfunction,int currview, int curvarfunction, int currvarview,class TransxMFD *tmfdpointer);
	void savecurrent(FILEHANDLE scn);
	void restoresave(FILEHANDLE scn);

	class TransxMFD *GetMFDpointer();//Returns pointer to current MFD
	//class basefunction *GetCurrFunction(); //Returns the current function
	class MFDvarhandler *GetVarhandler(int currvarfunction); //Gets the variable handler for the current function
	class MFDvariable *GetCurrVariable(int currvarfunction,int currviewmode); //Gets the current variable in the current function
	static void updatefocusvessel(OBJHANDLE newfocus); //Updates handles when vessel changes
	void updateownfocusvessel(OBJHANDLE newfocus); //Non-void section that updates focus vessel in every function
	bool sethelpsystem(bool thelpsystem) {helpsystem=thelpsystem;};
	bool fliphelpsystem(){return helpsystem=!helpsystem;};
	void togglefunctionswitch();
	static void createmapfunction();
	static void deletemapfunction();
	int getnumfunctions(){return numfunctions;};
	int movetonextfunction(int curvarfunction);//Step forward to next function, creating one if needed/possible
	int movetopreviousfunction(int curvarfunction);//Step back to previous function
	int inc_viewmode(int currfunction, int currview);//Increment viewmode
	class basefunction *getnextfunction(int positionnumber);
	class basefunction *getpreviousfunction(int positionnumber);
	class mapfunction *GetMapPointer(){return mappointer;};
	


private:
	bool initfunctions();
	bool checkbasefunction();
	bool initflag;
	bool saveflag;
	bool checkdelete();//delete one of the functions on the to delete list
	bool helpsystem;//On or off
	bool functionswitch;//whether to switch view with the variables
	bool mfdactive;
	int eastereggswitch;//Choose which Easter Egg to use
	UINT mfdid;//Number of MFD position
	int numfunctions,fnbaseposition,currcalcfunction;
	int deleteposition,enddellist;
	int actionframe;
	class TransxMFD *mfdpointer;

	static class mapfunction *mappointer;//The mapfunction pointer
	class basefunction *functionlist[NUMFUNCTIONS];//List of functions
	class basefunction *todeletelist[NUMFUNCTIONS];//List of functions to delete
	static bool statelistinitflag;//Has the list been initialised?
	OBJHANDLE hcraft;
};


#endif